<?php

function sqrl_aes_get($cookie, $part) {
  $function = 'sqrl_aes_get_' . $part;
  return $function($cookie);
}

function sqrl_aes_encrypt($data, $cookie = TRUE) {
  return aes_encrypt($data, FALSE, sqrl_aes_get_key($cookie), sqrl_aes_get_cipher($cookie), sqrl_aes_get_iv($cookie), sqrl_aes_get_implementation($cookie));
}

function sqrl_aes_decrypt($data, $cookie = TRUE) {
  return aes_decrypt($data, FALSE, sqrl_aes_get_key($cookie), sqrl_aes_get_cipher($cookie), sqrl_aes_get_iv($cookie), sqrl_aes_get_implementation($cookie));
}

function sqrl_aes_mode($cookie) {
  return $cookie ? 'cookie' : 'query';
}

function sqrl_aes_get_iv($cookie) {
  $key = 'sqrl_aes_iv_' . sqrl_aes_mode($cookie);
  $iv = variable_get($key, '');
  if (empty($iv) && defined('MCRYPT_MODE_CBC')) {
    if (strtoupper(substr(PHP_OS, 0, 3)) === "WIN") {
      $randgen = MCRYPT_RAND;
    }
    else {
      $randgen = MCRYPT_DEV_URANDOM;
    }

    $td = mcrypt_module_open(sqrl_aes_get_cipher($cookie), "", MCRYPT_MODE_CBC, "");
    $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), $randgen);
    mcrypt_module_close($td);
    $iv = base64_encode($iv);
    variable_set($key, $iv);
  }
  return $iv;
}

function sqrl_aes_get_implementation($cookie) {
  $key = 'sqrl_aes_implementation_' . sqrl_aes_mode($cookie);
  $implementation = variable_get($key, '');
  if (empty($implementation)) {
    $aes_config = aes_config();
    $implementations = $aes_config['aes']['aes_implementation']['#options'];
    $implementation = isset($implementations['mcrypt']) ? 'mcrypt' : 'phpseclib';
    variable_set($key, $implementation);
  }
  return $implementation;
}

function sqrl_aes_get_cipher($cookie) {
  $key = 'sqrl_aes_cipher_' . sqrl_aes_mode($cookie);
  $cipher = variable_get($key, '');
  if (empty($cipher)) {
    $cipher = 'rijndael-128';
    variable_set($key, $cipher);
  }
  return $cipher;
}

function sqrl_aes_get_key($cookie) {
  $key = 'sqrl_aes_key_' . sqrl_aes_mode($cookie);
  $enc_key = variable_get($key, '');
  if (empty($enc_key)) {
    $enc_key = user_password(30);
    variable_set($key, $enc_key);
  }
  return $enc_key;
}
